<?php

namespace SGalinski\SgJobs\ViewHelpers\Backend\Widget;

/***************************************************************
 *  Copyright notice
 *
 *  (c) sgalinski Internet Services (https://www.sgalinski.de)
 *
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/
use SGalinski\SgRoutes\ViewHelpers\Backend\Widget\Controller\PaginateController;
use TYPO3\CMS\Fluid\Core\Widget\AbstractWidgetViewHelper;

/**
 * Class PaginateViewHelper
 */
class PaginateViewHelper extends AbstractWidgetViewHelper {
	/**
	 * @var \SGalinski\SgRoutes\ViewHelpers\Backend\Widget\Controller\PaginateController
	 */
	protected $controller;

	/**
	 * Initializes the controller
	 *
	 * @param PaginateController $controller
	 */
	public function injectPaginateController(
		PaginateController $controller
	) {
		$this->controller = $controller;
	}

	/**
	 * Renders the paginator
	 *
	 * @param mixed $objects
	 * @param string $as
	 * @param array $configuration
	 * @return string
	 * @throws \TYPO3\CMS\Fluid\Core\Widget\Exception\MissingControllerException
	 */
	public function render(
		$objects, $as,
		array $configuration = ['itemsPerPage' => 10, 'insertAbove' => FALSE, 'insertBelow' => TRUE, 'recordsLabel' => '']
	) {
		return $this->initiateSubRequest();
	}
}
